import Vue, { PluginFunction, PluginObject, VueConstructor } from 'vue';
import { Store } from 'vuex';
import Router from 'vue-router';
import { IComponentInitParam } from './component';
import { IDirectiveInitParam } from './directive';
import { IFilterInitParam } from './filter';
import { IMixinInitParam } from './mixin';
import { IPluginInitParam } from './plugins';
import { IPrototypeInitParam } from './prototype';
import { IRouter, RouteConfig, RouterOptions } from './router';
import { IStore, StoreOptions } from './store';
import { IServiceWorkerOption } from './serviceWorker';
declare type IPluginObject<T> = PluginObject<T> | PluginFunction<T>;
export declare namespace Maintainer {
    interface IBuildEnv {
        env: string;
        isLocal: boolean;
        isDev: boolean;
        isStage: boolean;
        isPreProduction: boolean;
        isProduction: boolean;
    }
    interface IMaintainer<S> {
        buildEnv: IBuildEnv;
        router: Router | null;
        store: Store<S> | null;
    }
    interface IOption {
        showLogEnvs: string[];
        router?: {
            routes?: IRouter;
            fallback?: RouteConfig;
            option?: RouterOptions;
        };
        store?: {
            vuex: IPluginObject<any>;
            root: StoreOptions<any>;
            modules: IStore<any>;
        };
        plugins?: IPluginInitParam<any>;
        serviceWorker?: IServiceWorkerOption;
        prototype?: IPrototypeInitParam;
        filter?: IFilterInitParam;
        component?: IComponentInitParam;
        mixin?: IMixinInitParam;
        directive?: IDirectiveInitParam;
    }
    function initialize<V extends Vue, S>(vue: VueConstructor<V>, maintainerOption: IOption): IMaintainer<S>;
    function getBuildEnv(): IBuildEnv;
}
export {};
