import Vue, { VueConstructor } from 'vue';
import Router, { RouteConfig, Route, RouterOptions, NavigationGuard } from 'vue-router';
export { RouteConfig, RouterOptions } from 'vue-router';
export interface IRouter {
    [key: string]: RouteConfig[];
}
export interface INavigationGuards {
    beforeEach?(guard: NavigationGuard): void;
    beforeResolve?(guard: NavigationGuard): void;
    afterEach?(hook: (to: Route, from: Route) => any): void;
}
interface IRouterInitParam {
    routes?: IRouter;
    fallback?: RouteConfig;
    option?: RouterOptions;
    navigationGuards?: INavigationGuards;
}
export declare function initRouter<V extends Vue>(vueConstructor: VueConstructor<V>, router: IRouterInitParam): Router;
