import Vue, { PluginFunction, PluginObject, VueConstructor } from 'vue';
import { Store, StoreOptions } from 'vuex';
declare type IPluginObject<T> = PluginObject<T> | PluginFunction<T>;
export { StoreOptions } from 'vuex';
export interface IStoreData<S> {
    initialState: () => S;
    module: StoreOptions<S>;
}
export interface IStore<S> {
    [key: string]: IStoreData<S>;
}
interface IStoreInitParam<T, S> {
    vuex: IPluginObject<T>;
    root: StoreOptions<S>;
    modules: IStore<S>;
}
export declare function initStore<V extends Vue, T, S>(vueConstructor: VueConstructor<V>, store: IStoreInitParam<T, S>): Store<S>;
